<?php

namespace Proxies;

/**
 * THIS CLASS WAS GENERATED BY THE DOCTRINE ORM. DO NOT EDIT THIS FILE.
 */
class EntitiesStudentProxy extends \Entities\Student implements \Doctrine\ORM\Proxy\Proxy
{
    private $_entityPersister;
    private $_identifier;
    public $__isInitialized__ = false;
    public function __construct($entityPersister, $identifier)
    {
        $this->_entityPersister = $entityPersister;
        $this->_identifier = $identifier;
    }
    /** @private */
    public function __load()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            if ($this->_entityPersister->load($this->_identifier, $this) === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            unset($this->_entityPersister, $this->_identifier);
        }
    }
    
    
    public function login($login = NULL)
    {
        $this->__load();
        return parent::login($login);
    }

    public function number($number = NULL)
    {
        $this->__load();
        return parent::number($number);
    }

    public function name($name = NULL)
    {
        $this->__load();
        return parent::name($name);
    }

    public function lecture(\Entities\Lesson $lecture = NULL)
    {
        $this->__load();
        return parent::lecture($lecture);
    }

    public function laboratory(\Entities\Lesson $laboratory = NULL)
    {
        $this->__load();
        return parent::laboratory($laboratory);
    }

    public function tutorial(\Entities\Lesson $tutorial = NULL)
    {
        $this->__load();
        return parent::tutorial($tutorial);
    }

    public function deleted($deleted = NULL)
    {
        $this->__load();
        return parent::deleted($deleted);
    }

    public function addResult(\Entities\Result $result)
    {
        $this->__load();
        return parent::addResult($result);
    }

    public function course()
    {
        $this->__load();
        return parent::course();
    }

    public function results($part_name = NULL, $column = NULL)
    {
        $this->__load();
        return parent::results($part_name, $column);
    }

    public function resultsHistory()
    {
        $this->__load();
        return parent::resultsHistory();
    }

    public function addAction(\Entities\Action $action)
    {
        $this->__load();
        return parent::addAction($action);
    }

    public function actions()
    {
        $this->__load();
        return parent::actions();
    }

    public function addTeam(\Entities\Team $team)
    {
        $this->__load();
        return parent::addTeam($team);
    }

    public function teams()
    {
        $this->__load();
        return parent::teams();
    }


    public function __sleep()
    {
        return array('__isInitialized__', 'login', 'number', 'name', 'lecture', 'laboratory', 'tutorial', 'pno_kos', 'lno_kos', 'cno_kos', 'deleted', 'results', 'results_history', 'actions');
    }

    public function __clone()
    {
        if (!$this->__isInitialized__ && $this->_entityPersister) {
            $this->__isInitialized__ = true;
            $class = $this->_entityPersister->getClassMetadata();
            $original = $this->_entityPersister->load($this->_identifier);
            if ($original === null) {
                throw new \Doctrine\ORM\EntityNotFoundException();
            }
            foreach ($class->reflFields AS $field => $reflProperty) {
                $reflProperty->setValue($this, $reflProperty->getValue($original));
            }
            unset($this->_entityPersister, $this->_identifier);
        }
        
    }
}